
// Here are the dependencies needed to compile that code :
// worked with arduino IDE 1.8.13
// feel free to email me at:  littleplasticfactory(a)mailo.com
// Hope you manage to do something with it and sorry for my poor coding skill
 

#include <Wire.h>
#include <hd44780.h>
#include <hd44780ioClass/hd44780_I2Cexp.h>
#include <RotaryEncoder.h>
#include <PID_v1.h>
#include <SPI.h>                // For max31855 module
#include "Adafruit_MAX31855.h"  // For max31855 module
#include <EEPROM.h>             // To save and read data to the memory



        //The following parts needs to be here at the begining of the code

hd44780_I2Cexp lcd;     // declare lcd object: auto locate & auto config expander 

#define MAXDO   14      
#define MAXCS   A0      // we define thermocouple's inputs/outputs
#define MAXCLK  15      // And initialise the Thermocouple
                        
Adafruit_MAX31855 thermocouple(MAXCLK, MAXCS, MAXDO);

// We define a global variable for choosen temp
unsigned int choosen_temp = 0;

// And define others variables needed for temperature regulation of the extruder
byte pwm_heater = 0;

double tempthermo = 0; //intermediate variable for the PID algo. thermocouple must be defined earlier.
double tempSetpoint = choosen_temp, tempInput = tempthermo, tempOutput = pwm_heater;
const double PROGMEM TKp=1, TKi=0.05, TKd=0;
PID PIDheater(&tempInput, &tempOutput, &tempSetpoint, TKp, TKi, TKd, DIRECT);



           /////............global variables for filament diameter
int nbshad = 0;       //We define a variable that counts the amount of pixel wich value is under shadstep (see 06DiamSensor)           
int Pxshad = 0;      // We define a variable that takes nbshad's value before its reset to 0.
int Pxshadraw = 0;   // We define a variable that keeps the number of pixel in the shade before filtering.



// Here we defive variables needed for pusher module's speed regulation.
byte pwm_push = 0;
unsigned int DTarget = 25;
double pushSetpoint = DTarget, pushInput = Pxshad, pushOutput = pwm_push;
double PKp=0, PKi=0, PKd=0;
PID PIDpush(&pushInput, &pushOutput, &pushSetpoint, PKp, PKi, PKd, DIRECT);

//We define a variable that control Puller module's speed?
byte pwm_pull = 0;


  // Here we declare and initialise some functions for the main program

void (*pBfonct)() = &incdecCursor1;  // declare and init a pointer with a first function address

void (*pRefresh)() = &faitrien;   // declare and init a pointer with a first function address

void (*pAutoPush)() = &faitrien;   // declare and init a pointer with a first function address

String aPname = "AAAAAAAAAAAAAA";  // intermediary variable for preset name.
bool pushMode = 0;                 // variable needed to load/save pushmode state into presets



    // here is the setup code to start the programm
    
void setup() {

lcd.begin(20, 4);   // initialize the lcd
EncoderInit();      // initialize encodeur
ShowMain();         // show the main screen

// setup of some pins (some others are defined into program tabs)
 // pinMode(7, OUTPUT);           //CLK diamsens 
 // pinMode(8, OUTPUT);           //SI pin diamsens
 // pinMode(A3, INPUT_PULLUP);    //analog imput diamsens
  pinMode(6, INPUT_PULLUP);       // INPUT from encoder
  pinMode(9, OUTPUT);             // OUTPUT to PWM Puller module's 
  pinMode(5, OUTPUT);             // OUTPUT to PWM heater module's
  pinMode(10, OUTPUT);            // OUTPUT to PWM Pusher module's
  pinMode (1, INPUT_PULLUP);      // INPUT 2nd from encoder... Pin's name on board is A1
  
 // pinMode (A2, INPUT); //tentative de faire marcher le capteur de courrant ACS712
  //pinMode(A6, INPUT);   //on def l'entrée du capteur de temp de l'air


  setupDiamsens(); //setup of the diameter sensor

    // activation of some PIDs : 
  PIDheater.SetMode(AUTOMATIC);       // Heater PID activated 
  PIDheater.SetSampleTime(500);       // and set to 1/2 second of actuation
  PIDpush.SetMode(AUTOMATIC);         // Pusher PID activation
  PIDpush.SetOutputLimits(80, 255);   // we keep PID's output to usable limits for PWM pusher module.
  PIDpush.SetSampleTime(250);         // And set the PID loop to run every 250ms

  PresetsInitState();                 // We run a function that reads what is saved to the memory in order to be able to load it.

 }          

// Here is the main loop, the CalculDelais fonctions is here to help me understand what cost more time to be done in the program.

void loop() {
  
  Serial.println(F("checkbutton"));
  checkButton();                    // Here we call a function that read the state of encoder's button
  CalculDelais();
 // Serial.println(millis());
  Serial.println(F("Bfonct"));
  (*pBfonct)();                     // This is a pointer that call the desired function according to the program's state
 CalculDelais();                    // ... it can be to move the cursor, change a value or load a menu slide
 // Serial.println(millis());
  Serial.println(F("heater_control"));
  heater_control();                 // Here we call the heater regulation function
  CalculDelais();
 // Serial.println(millis());
  Serial.println(F("checkdiameter"));
  checkDiameter();                  // Call of measuring diameter function
  CalculDelais();
 // Serial.println(millis());
  Serial.println(F("pRefresh"));
  (*pRefresh)();                    // pointer that calls a function to refresh some part of the LCD
  CalculDelais();
 //   Serial.println(millis());
  Serial.println(F("pAutoPush"));
  (*pAutoPush)();                   // pointer that calls either the PID regulated pusher's function or the manual PWM control
  CalculDelais();
 //   Serial.println(millis());
    Serial.println(F("fin de boucle"));
    CalculDelais();

}


void CalculDelais()   // a small function to know how long another function takes to be executed
{
    static unsigned long Depart= 0;  
    Serial.println(millis()-Depart);
    Depart=millis();
}
